/* Generated by IBExpert 07.09.2002 19:28:36*/

SET SQL DIALECT 3;

SET NAMES NONE;

CREATE DATABASE 'LOCALHOST:D:\PD.GDB'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 1024
DEFAULT CHARACTER SET NONE;

CREATE GENERATOR GEN_ABONENT_ID;
CREATE GENERATOR GEN_ALIAS_ID;
CREATE GENERATOR GEN_XLAT_ID;
CREATE TABLE ABONENT (
    ID INTEGER NOT NULL,
    CHANNEL VARCHAR(32) NOT NULL,
    ADDRESS VARCHAR(32) NOT NULL);

CREATE TABLE ALIAS (
    ID INTEGER NOT NULL,
    NAME VARCHAR(32) NOT NULL,
    DESCR BLOB SUB_TYPE 1 SEGMENT SIZE 80);

CREATE TABLE ALIAS1 (
    ABONENTID INTEGER NOT NULL,
    ALIASID INTEGER NOT NULL);

CREATE TABLE STATUS (
    DATE1 DATE NOT NULL,
    ABONENTID INTEGER NOT NULL,
    TOTAL INTEGER NOT NULL);

CREATE TABLE STORAGE (
    STAMP TIMESTAMP NOT NULL,
    ABONENTID INTEGER NOT NULL,
    INFO VARCHAR(32) NOT NULL,
    MSG BLOB SUB_TYPE 1 SEGMENT SIZE 80);

CREATE TABLE XLAT (
    ID INTEGER NOT NULL,
    NAME VARCHAR(32) NOT NULL,
    XLAT BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    WORDS BLOB SUB_TYPE 1 SEGMENT SIZE 80);

CREATE TABLE XLAT1 (
    ABONENTID INTEGER NOT NULL,
    XLATID INTEGER NOT NULL);



ALTER TABLE ABONENT ADD CONSTRAINT UNQ_ABONENT UNIQUE (CHANNEL, ADDRESS);
ALTER TABLE ALIAS ADD CONSTRAINT UNQ_ALIAS UNIQUE (NAME);
ALTER TABLE ALIAS1 ADD CONSTRAINT UNQ_ALIAS1 UNIQUE (ABONENTID, ALIASID);
ALTER TABLE XLAT ADD CONSTRAINT UNQ_XLAT UNIQUE (NAME);
ALTER TABLE ABONENT ADD CONSTRAINT PK_ABONENT PRIMARY KEY (ID);
ALTER TABLE ALIAS ADD CONSTRAINT PK_ALIAS PRIMARY KEY (ID);
ALTER TABLE STATUS ADD CONSTRAINT PK_STATUS PRIMARY KEY (DATE1, ABONENTID);
ALTER TABLE XLAT ADD CONSTRAINT PK_XLAT PRIMARY KEY (ID);
ALTER TABLE XLAT1 ADD CONSTRAINT PK_XLAT1 PRIMARY KEY (ABONENTID, XLATID);
ALTER TABLE ALIAS1 ADD CONSTRAINT FK_ALIAS1 FOREIGN KEY (ABONENTID) REFERENCES ABONENT (ID);
ALTER TABLE ALIAS1 ADD CONSTRAINT FK_ALIAS2 FOREIGN KEY (ALIASID) REFERENCES ALIAS (ID);
ALTER TABLE STATUS ADD CONSTRAINT FK_STATUS FOREIGN KEY (ABONENTID) REFERENCES ABONENT (ID);
ALTER TABLE STORAGE ADD CONSTRAINT FK_STORAGE FOREIGN KEY (ABONENTID) REFERENCES ABONENT (ID);
ALTER TABLE XLAT1 ADD CONSTRAINT FK_XLAT1 FOREIGN KEY (ABONENTID) REFERENCES ABONENT (ID);
ALTER TABLE XLAT1 ADD CONSTRAINT FK_XLAT2 FOREIGN KEY (XLATID) REFERENCES XLAT (ID);
CREATE INDEX ABONENT_IDX1 ON ABONENT (ADDRESS);
CREATE INDEX STATUS_IDX1 ON STATUS (ABONENTID);
CREATE INDEX STORAGE_IDX1 ON STORAGE (STAMP);
CREATE DESCENDING INDEX STORAGE_IDX2 ON STORAGE (STAMP);
CREATE INDEX STORAGE_IDX3 ON STORAGE (ABONENTID);

SET TERM ^ ;





CREATE TRIGGER ABONENT_BI_BI FOR ABONENT
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_ABONENT_ID, 1);
END
^

CREATE TRIGGER ALIAS_BI_BI FOR ALIAS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_ALIAS_ID, 1);
END
^

CREATE TRIGGER XLAT_BI_BI FOR XLAT
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_XLAT_ID, 1);
END
^

SET TERM ; ^
